
; ===============================================================
; Mega PCM Driver Include File
; (c) 2012, Mike Berry
; ===============================================================

; ---------------------------------------------------------------
; Variables used in DAC table
; ---------------------------------------------------------------

; flags
panLR	= $C0
panL	= $80
panR	= $40
pcm	= 0
dpcm	= 4
loop	= 2
pri	= 1

; ---------------------------------------------------------------
; Macros
; ---------------------------------------------------------------

z80word macro Value
	dc.w	((\Value)&$FF)<<8|((\Value)&$FF00)>>8
	endm

DAC_Entry macro Pitch,Offset,Flags
	dc.b	\Flags			; 00h	- Flags
	dc.b	\Pitch			; 01h	- Pitch
	dc.b	(\Offset>>15)&$FF	; 02h	- Start Bank
	dc.b	(\Offset\_End>>15)&$FF	; 03h	- End Bank
	z80word	(\Offset)|$8000		; 04h	- Start Offset (in Start bank)
	z80word	(\Offset\_End-1)|$8000	; 06h	- End Offset (in End bank)
	endm
	
IncludeDAC macro Name,Extension
\Name:
	if strcmp('\extension','wav')
		incbin	'dac/\Name\.\Extension\',$3A
	else
		incbin	'dac/\Name\.\Extension\'
	endc
\Name\_End:
	endm

; ---------------------------------------------------------------
; Driver's code
; ---------------------------------------------------------------

MegaPCM:
	incbin	'MegaPCM.z80'

; ---------------------------------------------------------------
; DAC Samples Table
; ---------------------------------------------------------------

	DAC_Entry	$08, Kick, dpcm			; $81	- Kick
	DAC_Entry	$08, Snare, dpcm		; $82	- Snare
	DAC_Entry	$1B, Timpani, dpcm		; $83	- Timpani
	DAC_Entry	$07, V_hurt,  pcm+pri		; $84	- 'Hurt' voice
	DAC_Entry	$08, V_Dead1, pcm+pri		; $85	- 'Death1' voice
	DAC_Entry	$07, V_Dead2, pcm+pri		; $86	- 'Death2' voice
	DAC_Entry	$08, V_Ready, pcm+pri		; $87	- 'Ready' voice
	DAC_Entry	$12, Timpani, dpcm		; $88	- Hi-Timpani
	DAC_Entry	$15, Timpani, dpcm		; $89	- Mid-Timpani
	DAC_Entry	$1B, Timpani, dpcm		; $8A	- Mid-Low-Timpani
	DAC_Entry	$1D, Timpani, dpcm		; $8B	- Low-Timpani
	DAC_Entry	$07, V_1up,   pcm+pri		; $8C	- '1up' voice
	DAC_Entry	$08, V_Okay,   pcm+pri		; $8D	- 'Okay' voice
	DAC_Entry	$08, V_Timedeath,   pcm+pri	; $8E	- 'Timedeath' voice
	DAC_Entry	$07, V_Invinc,   pcm+pri	; $8F	- 'Inivinc' voice
	DAC_Entry	$08, v_Soundtest,   pcm+pri	; $90	- 'Soundtest' Voice

MegaPCM_End:

; ---------------------------------------------------------------
; DAC Samples Files
; ---------------------------------------------------------------

	IncludeDAC	Kick, bin
	IncludeDAC	Snare, bin
	IncludeDAC	Timpani, bin
	IncludeDAC	V_Hurt, wav
	IncludeDAC	V_Dead1, wav
	IncludeDAC	V_Dead2, wav
	IncludeDAC	V_Ready, wav
	IncludeDAC	v_1up, wav
	IncludeDAC	V_Okay, wav
	IncludeDAC	v_Timedeath, wav
	IncludeDAC	v_invinc, wav
	IncludeDAC	v_soundtest, wav
	even

